# MPI interface for the Julia language

[![Docs latest](https://img.shields.io/badge/docs-latest-blue.svg)](https://juliaparallel.github.io/MPI.jl/latest/)
[![Docs stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliaparallel.github.io/MPI.jl/stable/)
[![Build Status](https://travis-ci.com/JuliaParallel/MPI.jl.svg?branch=master)](https://travis-ci.com/JuliaParallel/MPI.jl)
[![Build status](https://ci.appveyor.com/api/projects/status/e8mr8rx8sjryyba6/branch/master?svg=true)](https://ci.appveyor.com/project/eschnett/mpi-jl/branch/master)
[![Build status](https://gitlab.com/JuliaGPU/MPI.jl/badges/master/pipeline.svg)](https://gitlab.com/JuliaGPU/MPI.jl/pipelines)
[![codecov.io](https://codecov.io/github/JuliaParallel/MPI.jl/coverage.svg?branch=master)](https://codecov.io/github/JuliaParallel/MPI.jl?branch=master)
[![Coverage Status](https://coveralls.io/repos/JuliaParallel/MPI.jl/badge.svg?branch=master&service=github)](https://coveralls.io/github/JuliaParallel/MPI.jl?branch=master)

This provides [Julia](http://julialang.org/) interface to the Message Passing Interface ([MPI](http://www.mpi-forum.org/)), roughly inspired by [mpi4py](http://mpi4py.scipy.org).

Please see the [documentation](https://juliaparallel.github.io/MPI.jl/stable/) for instructions on [installation](https://juliaparallel.github.io/MPI.jl/stable/installation/) and [usage](https://juliaparallel.github.io/MPI.jl/stable/usage/).

# Help and discussion

For help and discussion, we suggest asking on the following venues:
 - ["Julia at Scale" topic on the Julia Discourse](https://discourse.julialang.org/c/domain/parallel/34)
 - #distributed channel on the [Julia Slack](https://julialang.slack.com/) (visit [slackinvite.julialang.org](https://slackinvite.julialang.org/) to join).

# Contributing

Contributions are encouraged. In particular, MPI provides several hundred functions, only a small number of which are currently exposed. If there are additional functions you would like to use, please open an [issue](https://github.com/JuliaParallel/MPI.jl/issues) or [pull request](https://github.com/JuliaParallel/MPI.jl/pulls).

Additional examples and documentation improvements are also very welcome.
